// SessionDatesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rootfly.h"
#include "SessionDatesDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// SessionDatesDlg dialog


SessionDatesDlg::SessionDatesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(SessionDatesDlg::IDD, pParent)
{
  m_count = 0;
  m_max_sessions = 0;  
	//{{AFX_DATA_INIT(SessionDatesDlg)
	//}}AFX_DATA_INIT
}


void SessionDatesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(SessionDatesDlg)
	DDX_Control(pDX, IDC_EDIT_YEAR, m_edit_year);
	DDX_Control(pDX, IDC_EDIT_MONTH, m_edit_month);
	DDX_Control(pDX, IDC_EDIT_DAY, m_edit_day);
	DDX_Control(pDX, IDC_LIST_DATES, m_list_dates);
	DDX_Control(pDX, IDC_LIST_SESSIONS, m_list_sessions);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(SessionDatesDlg, CDialog)
	//{{AFX_MSG_MAP(SessionDatesDlg)
	ON_LBN_SELCHANGE(IDC_LIST_SESSIONS, OnSelchangeListSessions)
	ON_LBN_SELCHANGE(IDC_LIST_DATES, OnSelchangeListDates)
	ON_EN_UPDATE(IDC_EDIT_MONTH, OnUpdateEditMonth)
	ON_EN_UPDATE(IDC_EDIT_YEAR, OnUpdateEditYear)
	ON_EN_UPDATE(IDC_EDIT_DAY, OnUpdateEditDay)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SessionDatesDlg message handlers

void SessionDatesDlg::OnOK() 
{
  int index;
  CString invalid_string;
  bool valid_day, valid_month, valid_year;
  CString session;
  CString temp;
  if((GetFocus() == &m_edit_day) || (GetFocus() == &m_edit_month) ||
     (GetFocus() == &m_edit_year))
  {
    valid_day = ValidDay();
    valid_month = ValidMonth();
    valid_year = ValidYear();
    if( valid_day && valid_month && valid_year)
    {
      Date temp_date;      
      m_edit_day.GetWindowText(temp);
      temp_date.day = atoi(temp);
      m_edit_month.GetWindowText(temp);
      temp_date.month = atoi(temp);
      m_edit_year.GetWindowText(temp);
      temp_date.year = atoi(temp);
      index = m_list_dates.GetCurSel(); 
      m_dates.at(index) = temp_date;      

      // update list box
      m_list_dates.DeleteString(index);
      m_list_dates.InsertString(index,GetStringFromDate(temp_date));

      // increments index
      index = (index + 1)%(m_list_dates.GetCount() -1);
      UpdateEditBoxes(index);
      m_list_dates.SetCurSel(index);
      m_list_sessions.SetCurSel(index);
    } else
    {
      int invalid_count = 0;
      invalid_string = "Please enter valid date for the ";
      if(!valid_month)
      {
        invalid_string += "month";
        invalid_count++;
      }
      if(!valid_day)
      {
        if(invalid_count > 0) invalid_string += ", ";
        invalid_string += "day";
        invalid_count++;
      }
      if(!valid_year)
      {
        if(invalid_count > 0) invalid_string += ", ";
        invalid_string += "year.";
        invalid_count++;
      }
      AfxMessageBox(invalid_string);
    }
  } else CDialog::OnOK();

}

void SessionDatesDlg::OnSelchangeListSessions() 
{
  CString date, temp;
	int index = m_list_sessions.GetCurSel();
  m_list_dates.SetCurSel(index);
  UpdateEditBoxes(index);	
}

void SessionDatesDlg::OnSelchangeListDates() 
{
  CString date, temp;
	int index = m_list_dates.GetCurSel();
  m_list_sessions.SetCurSel(index);
  UpdateEditBoxes(index);  
}

// updates the edit boxes to display the selected item
void SessionDatesDlg::UpdateEditBoxes(int index)
{
  CString temp;
  int month, day, year;
  month = m_dates.at(index).month;
  day = m_dates.at(index).day;
  year = m_dates.at(index).year;
  
  // invalid date display - for the edit boxes
  if(month == -1)
  {
    m_edit_month.SetWindowText("");
    m_edit_day.SetWindowText("");
    m_edit_year.SetWindowText("");
  } else
  {
    temp.Format("%d",month);
    m_edit_month.SetWindowText(temp);
    temp.Format("%d",day);
    m_edit_day.SetWindowText(temp);
    temp.Format("%d",year);
    m_edit_year.SetWindowText(temp);
  }
}

CString SessionDatesDlg::GetStringFromDate(Date date)
{
  CString temp;
  // invalid date display -/-/- instead of -1/-1/-1
  if(date.month == -1)
  {
    temp = "-/-/-";
  } else
  {
    temp.Format("%d/%d/%d",date.month,date.day,date.year);
  }
  return temp;
}

BOOL SessionDatesDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
  CString session;
  CString str_date, temp, delim;
  std::vector<Date>::const_iterator p1;     

  // dates haven't been set if m_max_sessions isn't zero
  if(m_max_sessions != 0)
  {
    Date temp_date;
    temp_date.month = -1;
    temp_date.day = -1;
    temp_date.year = -1;
    temp.Format("%d", -1);
    str_date = GetStringFromDate(temp_date);
    for(int i = 1; i <= m_max_sessions; i++)
    {
      session.Format("%d",i);
      m_list_sessions.AddString(session);   
      m_list_dates.AddString(str_date);   
      m_dates.push_back(temp_date);
      m_count++;
    }

  } else  // dates have been preset. load the list boxes with them
  {        
    p1 = &m_dates.at(0);    
    m_max_sessions = m_dates.size();    
    for(int i = 0; i < m_max_sessions; i++)
    {
      session.Format("%d",i+1);
      m_list_sessions.AddString(session);
      str_date = GetStringFromDate(m_dates.at(i));      
      m_list_dates.AddString(str_date);
      m_count++;
      p1++;
    }
  }  
  // sets edit boxes to first item in list and selects item
  m_list_sessions.SetCurSel(0);
  m_list_dates.SetCurSel(0);
  UpdateEditBoxes(0);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// returns the list of session dates
const std::vector<Date> SessionDatesDlg::GetSessionDates()
{
  return m_dates;
}

// sets initial list of session dates
void SessionDatesDlg::SetSessionDates(std::vector<Date> session_dates)
{
  m_dates = session_dates;  
}

void SessionDatesDlg::OnUpdateEditMonth() 
{
  CString text;
  int month;
	m_edit_month.GetWindowText(text);
  month = atoi(text);
  if(month > 12)
  {
    if(month % 100 < 12) month = month %10;
    else month = month % 10;
    text.Format("%d",month);
    m_edit_month.SetWindowText(text);
  }
}

void SessionDatesDlg::OnUpdateEditYear() 
{
  CString text;
  int year;
	m_edit_year.GetWindowText(text);
  year = atoi(text);
  if(year > 2050)
  {
    if(year % 10000 <= 2050 && year % 10000 > 1900) year = year % 10000;
    else year = year % 1000;
    text.Format("%d",year);
    m_edit_year.SetWindowText(text);
  }
}

void SessionDatesDlg::OnUpdateEditDay() 
{
  CString text;
  int day;
	m_edit_day.GetWindowText(text);
  day = atoi(text);
  if(day > 31)
  {
    if(day % 100 < 31) day = day % 100;
    else day = day % 10;
    text.Format("%d",day);
    m_edit_day.SetWindowText(text);
  }
}

bool SessionDatesDlg::ValidMonth()
{
  CString text;
  int month;
	m_edit_month.GetWindowText(text);
  month = atoi(text);
  if(month > 0 && month <= 12) return true;
  else return false;
}

bool SessionDatesDlg::ValidDay()
{
  CString text;
  int day;
	m_edit_day.GetWindowText(text);
  day = atoi(text);
  if(day > 0 && day <= 31) return true;
  else return false;
}

bool SessionDatesDlg::ValidYear()
{
  CString text;
  int year;
	m_edit_year.GetWindowText(text);
  year = atoi(text);
  if(year >= 1900 && year <= 2100) return true;
  else return false;
}